var ConfigProp = null;

function makeItem(fieldname, description, property, type, group, defaultValue)
{
    var propertyName = property.split("/").join("_")
    var ItemBaseProp = new Property("config/" + group + "/item_" + propertyName);
    ItemBaseProp.setFlag('ARCHIVE', true);
    ItemBaseProp = new Property("config/" + group + "/item_" + propertyName + "/fieldname");
    ItemBaseProp.setFlag('ARCHIVE', true);
    ItemBaseProp.setValue(fieldname);
    ItemBaseProp = new Property("config/" + group + "/item_" + propertyName + "/description");
    ItemBaseProp.setFlag('ARCHIVE', true);
    ItemBaseProp.setValue(description);
    ItemBaseProp = new Property("config/" + group + "/item_" + propertyName + "/property");
    ItemBaseProp.setFlag('ARCHIVE', true);
    ItemBaseProp.setValue(property);
    ItemBaseProp = new Property("config/" + group + "/item_" + propertyName + "/type");
    ItemBaseProp.setFlag('ARCHIVE', true);
    ItemBaseProp.setValue(type);
    
    ItemBaseProp = new Property("config/" + group + "/item_" + propertyName + "/default");
    ItemBaseProp.setFlag('ARCHIVE', true);
    if (defaultValue != null) 
        ItemBaseProp.setValue(defaultValue);
}


function makeGroup(groupID, groupName)
{
    if (ConfigProp == null) 
    {
        ConfigProp = new Property("config");
        ConfigProp.setFlag('ARCHIVE', true);
    }
    
    
    var GroupProp = new Property("config/" + groupID);
    GroupProp.setFlag('ARCHIVE', true);
    var GroupNameProp = new Property("config/" + groupID + "/name");
    GroupNameProp.setFlag('ARCHIVE', true);
    GroupNameProp.setValue(groupName);
}


function saveProps()
{
    Property.store();
}


function loadProps()
{
    Property.load();
    var prop = Property.getNode('config');
    if (prop == null) 
    {
        if (prepareProps) 
            prepareProps();
        Property.store();
    }
}


function _propertyMain()
{
    if (raisedEvent.parameter.actions != null) 
    {
        if (raisedEvent.parameter.actions === "save") 
        {
            saveProps();
            return true;
        }
        if (raisedEvent.parameter.actions === "load") 
        {
            loadProps();
            return true;
        }
    }
    return false;
}


function executeAction(sString)
{
    var sTempArray = sValue.split(";");
    for (var iIndex = 0; iIndex < sTempArray.length; iIndex++) 
    {
        var sText = sTempArray[iIndex];
        if (sText != "") 
        {
            var oTemp = sText.split(":");
            if (oTemp[0] == "HLE") 
            {
                log("raise event: " + oTemp[1]);
                var theEvent = new event(oTemp[1], {});
                theEvent.raise();
            }
            else 
            {
                var object = null;
                if (oTemp[0] == "Device") 
                {
                    object = getDevices().byDSID(oTemp[1]);
                }
                if (oTemp[0] == "Zone") 
                {
                    object = getDevices().byZone(parseInt(oTemp[1])).byGroup(parseInt(oTemp[3]));
                }
                if (oTemp[4] == "Scene") 
                {
                    object.callScene(parseInt(oTemp[5]));
                }
                if (oTemp[4] == "Output") 
                {
                    var output = parseInt(oTemp[5]);
                    output = output * 255;
                    output = output / 100;
                    object.setValue(output);
                }
                if (oTemp[4] == "Blink") 
                {
                    object.blink();
                }
            }
        }
    }
    
}
