Ext.namespace('Configurator');

Ext.form.VTypes["hostnameVal1"] = /^[a-zA-Z][-.a-zA-Z0-9]{0,254}$/;
Ext.form.VTypes["hostnameVal2"] = /^[a-zA-Z]([-a-zA-Z0-9]{0,61}[a-zA-Z0-9]){0,1}([.][a-zA-Z]([-a-zA-Z0-9]{0,61}[a-zA-Z0-9]){0,1}){0,}$/;
Ext.form.VTypes["ipVal"] = /^([1-9][0-9]{0,1}|1[013-9][0-9]|12[0-689]|2[01][0-9]|22[0-3])([.]([1-9]{0,1}[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])){2}[.]([1-9][0-9]{0,1}|1[0-9]{2}|2[0-4][0-9]|25[0-4])$/;
Ext.form.VTypes["portVal"] = /^(0|[1-9][0-9]{0,3}|[1-5][0-9]{4}|6[0-4][0-9]{3}|65[0-4][0-9]{2}|655[0-2][0-9]|6553[0-5])$/;

Ext.form.VTypes["ip"] = function(v)
{
    return Ext.form.VTypes["ipVal"].test(v);
};
Ext.form.VTypes["ipText"] = "1.0.0.1 - 223.255.255.254 excluding 127.x.x.x";
Ext.form.VTypes["ipMask"] = /[.0-9]/;

Ext.form.VTypes["port"] = function(v)
{
    return Ext.form.VTypes["portVal"].test(v);
};
Ext.form.VTypes["portText"] = "0 - 65535";
Ext.form.VTypes["portMask"] = /[0-9]/;

Configurator.VERSION = '0.1.2';
Configurator.jsonData = null;

function querySt(ji)
{
    hu = window.location.search.substring(1);
    gy = hu.split("&");
    for (i = 0; i < gy.length; i++) 
    {
        ft = gy[i].split("=");
        if (ft[0] == ji) 
        {
            return ft[1];
        }
    }
}


Configurator.oModulName = querySt("name");
if (Configurator.oModulName == null) 
{
    var oArray = document.URL.split("/");
    Configurator.oModulName = oArray[oArray.length - 2];
}

function setQuery(sProp, sValue)
{
    var sURL = "";
    var sPfad = escape("/scripts/" + Configurator.oModulName + "/" + sProp);
    if (sProp[0] == "/") 
        sPfad = escape(sProp);
    if (typeof(sValue) == "number") 
    {
        sURL = '/json/property/setInteger?path=' + sPfad + "&value=" + escape(sValue);
    }
    else if (typeof(sValue) == "boolean") 
    {
        sURL = '/json/property/setBoolean?path=' + sPfad + "&value=" + escape(sValue);
    }
    else 
        sURL = '/json/property/setString?path=' + sPfad + "&value=" + escape(sValue);
    Ext.Ajax.request(
    {
        url: sURL,
        disableCaching: true,
        timeout: 300000,
        method: "GET",
        scope: this,
        success: function(result, request)
        {
            try 
            {
            } 
            catch (err) 
            {
                Ext.MessageBox.alert("Error", "Could not load dialog description" + ": \"" +
                err +
                "\"");
            }
        }
        
    });
    sURL = '/json/property/setFlag?path=' + sPfad + "&value=true&flag=ARCHIVE";
    
    Ext.Ajax.request(
    {
        url: sURL,
        disableCaching: true,
        timeout: 300000,
        method: "GET",
        scope: this,
        success: function(result, request)
        {
            try 
            {
            } 
            catch (err) 
            {
                Ext.MessageBox.alert("Error", "Could not load dialog description" + ": \"" +
                err +
                "\"");
            }
        }
        
    });
}


function save()
{
    Ext.Ajax.request(
    {
        url: '/json/event/raise?name=' + escape(Configurator.oModulName) + "&parameter=" + escape("actions=save"),
        disableCaching: true,
        timeout: 300000,
        method: "GET",
        success: function(result, request)
        {
        },
        failure: function(result, request)
        {
            this.loadingStructure = false;
            Ext.MessageBox.alert("Error", "Could not dialog description" + ": \"" +
            request.url +
            "\"");
        }
        
    });
    
}


var fsf;

function buildUp(data, scope)
{
    Ext.get('start').remove();
    // Init the singleton.  Any tag-based quick tips will start working.
    Ext.QuickTips.init();
    
    // Apply a set of config properties to the singleton
    Ext.apply(Ext.QuickTips.getQuickTip(), 
    {
        maxWidth: 300,
        minWidth: 200,
        showDelay: 50, // Show 50ms after entering target
        trackMouse: true
    });
    
    // Manually register a quick tip for a specific element
    
    fsf = new Ext.FormPanel(
    {
        labelWidth: 75, // label settings here cascade unless overridden
        url: '',
        frame: true,
        title: 'Konfiguration',
        bodyStyle: 'padding:5px 5px 0',
        width: 450,
        buttons: [
        {
            text: 'Speichern',
            handler: function()
            {
                if (fsf.getForm().isValid()) 
                {
                    for (propName in Configurator.dataTemplate) 
                    {
                        if (Configurator.dataTemplate[propName].type != "description") 
                        {
                            var item = Configurator.dataTemplate[propName].item;
                            if (Configurator.dataTemplate[propName].type == "integer") 
                                setQuery(propName, parseInt(item.getValue()));
                            else if (Configurator.dataTemplate[propName].type == "boolean") 
                                setQuery(propName, item.getValue());
                            else 
                                setQuery(propName, item.getValue());
                        }
                    }
                    save();
                }
            }
            
        }]
    });
    
    Configurator.dataTemplate = {};
    for (var iIndex = 0; iIndex < data.length; iIndex++) 
    {
        var groupJsonData = data[iIndex];
        
        var group = new Ext.form.FieldSet(
        {
            xtype: 'fieldset',
            title: groupJsonData.name,
            autoHeight: true,
            defaults: 
            {
                width: '100%'
            },
            defaultType: 'textfield'
        });
        
        fsf.add(group);
        
        for (oKey in groupJsonData) 
        {
            if (oKey != "name") 
                for (var iItem = 0; iItem < groupJsonData[oKey].length; iItem++) 
                {
                    var item = null;
                    var getterURL = null;
                    var itemData = groupJsonData[oKey][iItem];
                    var typeArray;
                    if (itemData.type != null) 
                    {
                        typeArray = itemData.type.split(".");
                        Configurator.dataTemplate[itemData.property] = {};
                        Configurator.dataTemplate[itemData.property].type = typeArray[0];
                        
                        var sPfad = escape("/scripts/" + Configurator.oModulName + "/" + itemData.property);
                        if (itemData.property == "/") 
                            sPfad = escape(sProp);
                        
                        if (typeArray[0] == "description") 
                        {
                            item = new Ext.form.Label(
                            {
                                text: itemData.description,
                                disabled: false
                            });
                            getterURL = null;
                        }
                        else if (typeArray[0] == "integer") 
                        {
                            item = new Ext.form.NumberField(
                            {
                                fieldLabel: itemData.fieldname,
                                name: itemData.property,
                                disabled: true
                            });
                            if (itemData['default'] != null) 
                                item.setValue(parseInt(itemData['default']));
                            getterURL = '/json/property/getInteger?path=' + sPfad;
                        }
                        else if (typeArray[0] == "boolean") 
                        {
                            item = new Ext.form.CheckBox(
                            {
                                fieldLabel: itemData.fieldname,
                                name: itemData.property,
                                disabled: true
                            });
                            getterURL = '/json/property/getBoolean?path=' + sPfad;
                        }
                        else 
                        {
                            getterURL = '/json/property/getString?path=' + sPfad;
                            
                            if (typeArray[1] == "action") 
                            {
                                item = new Configurator.ActionPanel(
                                {
                                    title: itemData.fieldname,
                                    name: itemData.property
                                });
                            }
                            else if (typeArray[1] == "password") 
                            {
                                item = new Ext.form.TextField(
                                {
                                    fieldLabel: itemData.fieldname,
                                    inputType: "password",
                                    name: itemData.property,
                                    disabled: true
                                });
                            }
                            else if (typeArray[1] == "ip") 
                            {
                                item = new Ext.form.TextField(
                                {
                                    fieldLabel: itemData.fieldname,
                                    name: itemData.property,
                                    vtype: 'ip',
                                    disabled: true
                                });
                            }
                            else if (typeArray[1] == "url") 
                            {
                                item = new Ext.form.TextField(
                                {
                                    fieldLabel: itemData.fieldname,
                                    name: itemData.property,
                                    disabled: true
                                });
                            }
                            else if (typeArray[1] == "email") 
                            {
                                item = new Ext.form.TextField(
                                {
                                    fieldLabel: itemData.fieldname,
                                    name: itemData.property,
                                    disabled: true
                                });
                            }
                            else 
                            {
                                item = new Ext.form.TextField(
                                {
                                    fieldLabel: itemData.fieldname,
                                    name: itemData.property,
                                    disabled: true
                                });
                            }
                            if (itemData['default'] != null) 
                                if (itemData['default'] != "") 
                                    item.setValue(itemData['default']);
                        }
                    }
                    if (item != null) 
                    {
                        Configurator.dataTemplate[itemData.property].item = item;
                        Ext.QuickTips.register(
                        {
                            target: item,
                            title: itemData.fieldname,
                            text: itemData.description,
                            dismissDelay: 10000 // Hide after 10 seconds hover
                        });
                        
                        group.add(item);
                        if (getterURL != null) 
                            Ext.Ajax.request(
                            {
                                url: getterURL,
                                disableCaching: true,
                                timeout: 300000,
                                method: "GET",
                                scope: item,
                                success: function(result, request)
                                {
                                    try 
                                    {
                                        var resData = Ext.util.JSON.decode(result.responseText);
                                        if (resData.ok) 
                                            this.setValue(resData.result.value);
                                        this.setDisabled(false);
                                    } 
                                    catch (err) 
                                    {
                                        Ext.MessageBox.alert("Error", "Could not load dialog description" + ": \"" +
                                        err +
                                        "\"");
                                    }
                                }
                                
                            });
                    }
                }
        }
        
    }
    
    scope.viewport = new Ext.Viewport(
    {
        hideBorders: true,
        layout: 'border',
        items: [
        {
            autoScroll: true,
            region: 'center',
            xtype: 'panel',
            items: [fsf]
        }]
    });
    
}


function makePrepare(myscope)
{
    Ext.Ajax.request(
    {
        url: '/json/event/raise?name=' + escape(Configurator.oModulName) + "&parameter=" + escape("actions=load"),
        disableCaching: true,
        timeout: 300000,
        method: "GET",
        scope: myscope,
        success: function(result, request)
        {
            try 
            {
                Configurator.jsonData = Ext.util.JSON.decode(result.responseText);
                if (Configurator.jsonData.ok) 
                {
                    Ext.Ajax.request(
                    {
                        url: '/json/property/query?query=' + escape("/scripts/" + Configurator.oModulName + "/config/*(name)/*(fieldname,description,property,type,default)"),
                        disableCaching: true,
                        timeout: 300000,
                        method: "GET",
                        scope: this,
                        success: function(result, request)
                        {
                            try 
                            {
                                Configurator.jsonData = Ext.util.JSON.decode(result.responseText);
                                if (Configurator.jsonData.ok) 
                                {
                                    if (Configurator.jsonData.result.config != null) 
                                        buildUp(Configurator.jsonData.result.config, this);
                                }
                            } 
                            catch (err) 
                            {
                                Ext.MessageBox.alert("Error", "Could not load dialog description" + ": \"" +
                                err +
                                "\"");
                            }
                            this.loadingStructure = false;
                        },
                        failure: function(result, request)
                        {
                            this.loadingStructure = false;
                            Ext.MessageBox.alert("Error", "Could not dialog description" + ": \"" +
                            request.url +
                            "\"");
                        }
                        
                    });
                    
                    
                }
            } 
            catch (err) 
            {
                Ext.MessageBox.alert("Error", "Could not load dialog description" + ": \"" +
                err +
                "\"");
            }
            this.loadingStructure = false;
        },
        failure: function(result, request)
        {
            this.loadingStructure = false;
            Ext.MessageBox.alert("Error", "Could not dialog description" + ": \"" +
            request.url +
            "\"");
        }
        
    });
}


function firstTry(scope)
{
    Ext.Ajax.request(
    {
        url: '/json/property/query?query=' + escape("/scripts/" + Configurator.oModulName + "/config/*(name)/*(fieldname,description,property,type,default)"),
        disableCaching: true,
        timeout: 300000,
        method: "GET",
        scope: this,
        success: function(result, request)
        {
            try 
            {
                Configurator.jsonData = Ext.util.JSON.decode(result.responseText);
                if (Configurator.jsonData.ok) 
                {
                    if (Configurator.jsonData.result.config != null) 
                        buildUp(Configurator.jsonData.result.config, this);
                    else 
                        makePrepare(scope);
                }
            } 
            catch (err) 
            {
                Ext.MessageBox.alert("Error", "Could not load dialog description" + ": \"" +
                err +
                "\"");
            }
            this.loadingStructure = false;
        },
        failure: function(result, request)
        {
            this.loadingStructure = false;
            Ext.MessageBox.alert("Error", "Could not dialog description" + ": \"" +
            request.url +
            "\"");
        }
        
    });
}


Ext.onReady(function()
{
    Ext.Ajax.request(
    {
        url: '/json/system/login?user=dssadmin&password=dssadmin',
        disableCaching: true,
        timeout: 300000,
        method: "GET",
        scope: this,
        success: function(result, request)
        {
            try 
            {
                firstTry(this);
            } 
            catch (err) 
            {
                Ext.MessageBox.alert("Error", "Could not load dialog description" + ": \"" +
                err +
                "\"");
            }
            this.loadingStructure = false;
        },
        failure: function(result, request)
        {
            this.loadingStructure = false;
            Ext.MessageBox.alert("Error", "Could not dialog description" + ": \"" +
            request.url +
            "\"");
        }
        
    });
});
